﻿using UnityEngine;
using System.Collections;

public class Mothership_Behaviour : MonoBehaviour {
	
	//number of time the motherships was hit by some object(presumably only pellet wil hit it)
	int hits;
	
	//ship prefabs(types)
	public Transform octopusShip;
	public Transform frogShip;
	public Transform spiderShip;
	//ship wave numbers
	public int octopusNumber;
	public int frogNumber;
	public int spiderNumber;
	//a temporary variable used for counting wave numbers
	int waveCounter;
	//a temporary variable used for keeping track of time
	float tempTimeBetweenRelease;
	//how long time goes between each ship is spawned from the mothership
	public float timeBetweenRelease;
	//controls the interval between the dropping of each shipType
	public float timeBetweenWave;
	
	//the current shipType that is spawning
	string shipType;
	
	// Use this for initialization
	void Start () {
		//the first shipType to be spawned
		shipType = "octopus";
		waveCounter = octopusNumber;
		
		tempTimeBetweenRelease = timeBetweenWave;
	}
	
	void OnCollisionEnter(Collision collision)
	{
		//if hit by pellet, add +1 to this variable that stores the number of hits
		hits++;
		//kill the pellet from this script.
		Destroy(collision.gameObject);
	}
	
	// Update is called once per frame
	void Update () {
		
		tempTimeBetweenRelease-=Time.deltaTime;
		if(shipType == "octopus")
		{
			//if there are still ships to be spawned
			if(waveCounter>0)
			{
				//if time between the last spawn and the next one has passed
				if((tempTimeBetweenRelease<=0))
				{
					spawnOctopus();
					tempTimeBetweenRelease = timeBetweenRelease;
					//subtract 1 from the counter for wave number of this ship type
					waveCounter--;
				}				
			}
			else
			{
				shipType = "frog";
				waveCounter = frogNumber;
				tempTimeBetweenRelease = timeBetweenWave;
			}
		}
		else if (shipType == "frog")
			{
				if(waveCounter>0)
				{
					if(tempTimeBetweenRelease<=0)
					{
						spawnFrog();
						tempTimeBetweenRelease = timeBetweenRelease;
						//subtract 1 from the counter for wave number of this ship type
						waveCounter--;
					}				
				}
				else
				{
					shipType = "spider";
					waveCounter = spiderNumber;
					tempTimeBetweenRelease = timeBetweenWave;
				}				
			}
		else if (shipType == "spider")
			{
				if(waveCounter>0)
				{
					if((tempTimeBetweenRelease<=0))
					{
						spawnSpider();
						tempTimeBetweenRelease = timeBetweenRelease;
						//subtract 1 from the counter for wave number of this ship type
						waveCounter--;
					}				
				}
				else
				{
					shipType = "octopus";
					waveCounter = octopusNumber;
					tempTimeBetweenRelease = timeBetweenWave;
				}				
			}		
	}
	
	//spawn functions
//	void spawnCycle()
//	{
//		if(shipType == "octopus")
//		{
//			if(waveCounter > 1)
//			{InvokeRepeating("spawnOctopus",0f, timeBetweenRelease);}
//			else 
//			{
//				CancelInvoke("spawnOctopus");
//				shipType = "frog";
//				waveCounter = frogNumber;
//			}
//		}
//		else if(shipType == "frog")
//			{
//				if(waveCounter > 1)
//				{InvokeRepeating("spawnFrog",0f, timeBetweenRelease);}
//				else 
//				{
//					CancelInvoke("spawnFrog");
//					shipType = "spider";
//					waveCounter = spiderNumber;
//				}
//			}
//		else if(shipType == "spider")
//			{
//				if(waveCounter > 1)
//				{InvokeRepeating("spawnSpider",0f, timeBetweenRelease);}
//				else 
//				{
//					CancelInvoke("spawnSpider");
//					shipType = "octopus";
//					waveCounter = octopusNumber;
//				}
//			}
//			 
//	}
	
	void spawnOctopus()
	{
		//spawn octopus just bellow mothership
		Instantiate(octopusShip, transform.position + new Vector3(0f,-2f,0f),  Quaternion.identity);
	}
	void spawnFrog()
	{
		//spawn frog bellow mothership
		Instantiate(frogShip, transform.position + new Vector3(0f,-2f,0f),  Quaternion.identity);
	}
	void spawnSpider()
	{
		//spawn spider bellow mothership
		Instantiate(spiderShip, transform.position + new Vector3(0f,-2f,0f),  Quaternion.identity);
	}
	
	//prints hits as gui element
	void OnGUI () 
	{
		
		GUI.Label(new Rect(150, 10, 100, 20), "Hits: " + hits);
	}	
}
